<?php
/********************************************************************

	TPV La Caixa por servired
	=========================


	28-09-2007 Version 3.0
	
	- Campo Terminal configurable por el admin
	- Ahora funciona correctamente la notificacion online (No se pierden pedidos)
	
------------------------------------------------------------------------	

	4-12-2006 ltima edicin por Jordi (atencion_clientes@hotmail.com)
	
	- Aadido los nuevos campos necesarios para funcionar bajo la caixa
	- Cambiada la encriptacin.
	- Aadidos cambios de albert martin (grcias)
	- Instalacion con la web de la caixa por defecto

	En los foros en espaol de oscommerce podreis encontrar la ayuda que necesiteis
	http://oscommerce.qadram.com/modules.php?name=Forums

**********************************************************************	
	
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Servired Payment Module 
  Copyright (c) 2004 qadram software
  http://www.qadram.com

  Released under the GNU General Public License
*/


  class servired {
    var $code, $title, $description, $enabled;

// class constructor
    function servired() {
      global $order;

      $this->code = 'servired';
      $this->title = MODULE_PAYMENT_SERVIRED_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_SERVIRED_TEXT_DESCRIPTION;
      $this->enabled = ((MODULE_PAYMENT_SERVIRED_STATUS == 'True') ? true : false);      
      $this->sort_order = MODULE_PAYMENT_SERVIRED_SORT_ORDER;

      if ((int)MODULE_PAYMENT_SERVIRED_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SERVIRED_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = MODULE_PAYMENT_SERVIRED_URL;      
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SERVIRED_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SERVIRED_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
      
      if ((MODULE_PAYMENT_SERVIRED_ID_SEED == 'qwertyasdf0123456789') && ($order->customer['email_address'] != MODULE_PAYMENT_SERVIRED_MAIL)) {
          $this->enabled = false;
      }
      
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }
    
   

    function process_button() 
    {
      global $order, $currency, $language;
      

      $ds_merchant_order="1".time();
      
      //Merchant Data
      $ds_merchant_data=tep_session_id();
      
      //Amount
      $total=$order->info['total'];      	
      $ds_merchant_amount = round($total*$order->info['currency_value'],2);
      $ds_merchant_amount = number_format($ds_merchant_amount, 2, '.', '');
      $ds_merchant_amount = preg_replace('/\./', '', $ds_merchant_amount);
      
      
      $ds_merchant_currency = "978";
      
      // Cambio de terminal por el 2
      $ds_merchant_terminal = MODULE_PAYMENT_SERVIRED_TERMINAL;
      
      // Aadidos los dos nuevos campos de tipo de transaccion e idioma por defecto      
	  	$ds_merchant_transactiontype = "0";
      $ds_merchant_consumerlanguage = "1";        
      
      if ($currency=='USD')
      {
      	$ds_merchant_currency = "840";
      	$ds_merchant_terminal = "3";        	
      }
      elseif ($currency!='EUR')
      {
      	$total=$order->info['total'];      	
      	$ds_merchant_amount = round($total,2);
      	$ds_merchant_amount = number_format($ds_merchant_amount, 2, '.', '');
      	$ds_merchant_amount = preg_replace('/\./', '', $ds_merchant_amount);      	
      }
      
      if ($language=='english') 
      {
      	$ds_merchant_consumerlanguage='2';
      }
      elseif ($language=='catala') 
      {
      	$ds_merchant_consumerlanguage='3';
      }      
      
    
      $seed=MODULE_PAYMENT_SERVIRED_ID_SEED;
      
      $ds_merchant_code=MODULE_PAYMENT_SERVIRED_ID_COM;     
       
      // Gracias martinm por la idea de la session_name :) 
     	$recuperar_sesion = tep_session_id();  // Recojemos la sesion para recuperarla al volver con la notificacion, genere el pedido y vacie el carrito
			$ds_merchant_merchanturl = tep_href_link(FILENAME_CHECKOUT_PROCESS, session_name().'='.$recuperar_sesion, 'NONSSL',false);
			$ds_merchant_urlok = tep_href_link(FILENAME_CHECKOUT_SUCCESS, session_name().'='.$recuperar_sesion, 'NONSSL',false);	// Como el pedido ya estar generado vamos directo al success
			$ds_merchant_urlko = tep_href_link(FILENAME_CHECKOUT_PROCESS, session_name().'='.$recuperar_sesion, 'NONSSL',false);	// Si ha habido algun error volvemos al process, que nos llevara al pago de nuevo con el error correspondientemente tratado.
 
        
      $sha = new SHA1;
      $message = $ds_merchant_amount.$ds_merchant_order.$ds_merchant_code.$ds_merchant_currency.$ds_merchant_transactiontype.$ds_merchant_merchanturl.$seed;
			
			// Nueva encriptacin por sha1			    
      $signature = strtoupper (sha1( $message ));
     
     	$Descripcion = $order->customer['lastname'].", ".$order->customer['firstname']." (".$order->customer['email_address'].")";
     
     // Se han aadido los nuevos inputs
      $process_button_string = 
			       tep_draw_hidden_field('Ds_Merchant_Amount', $ds_merchant_amount) .
			       tep_draw_hidden_field('Ds_Merchant_Currency', $ds_merchant_currency) .
			       tep_draw_hidden_field('Ds_Merchant_Order', $ds_merchant_order) .
             tep_draw_hidden_field('Ds_Merchant_ProductDescription', $Descripcion) .
             tep_draw_hidden_field('Ds_Merchant_Titular', TITLE) .
			       tep_draw_hidden_field('Ds_Merchant_MerchantCode', $ds_merchant_code) .
			       tep_draw_hidden_field('Ds_Merchant_MerchantURL', $ds_merchant_merchanturl) .
			       tep_draw_hidden_field('Ds_Merchant_UrlOK', $ds_merchant_urlok) .
			       tep_draw_hidden_field('Ds_Merchant_UrlKO', $ds_merchant_urlko) .
			       tep_draw_hidden_field('Ds_Merchant_ConsumerLanguage', $ds_merchant_consumerlanguage) .
             tep_draw_hidden_field('Ds_Merchant_MerchantSignature', $signature).
			       tep_draw_hidden_field('Ds_Merchant_Terminal', $ds_merchant_terminal) .
             tep_draw_hidden_field('Ds_Merchant_TransactionType', $ds_merchant_transactiontype) .
			       tep_draw_hidden_field('Ds_Merchant_MerchantData', $ds_merchant_data);
     
     return $process_button_string;
    }

    function before_process() 
    {
			  $seed=MODULE_PAYMENT_SERVIRED_ID_SEED;
			          	
			  $ds_date=$_REQUEST['Ds_Date'];
			  $ds_hour=$_REQUEST['Ds_Hour'];    	
			  $ds_amount=$_REQUEST['Ds_Amount'];    	
			  $ds_currency=$_REQUEST['Ds_Currency'];    	
			  $ds_order=$_REQUEST['Ds_Order'];    	
			  $ds_merchantcode=$_REQUEST['Ds_MerchantCode'];    	
			  $ds_terminal=$_REQUEST['Ds_Terminal'];    	
			  $ds_signature=$_REQUEST['Ds_Signature'];    	
			  $ds_response=$_REQUEST['Ds_Response'];
			  $ds_transactiontype=$_REQUEST['Ds_TransactionType'];	
			  $ds_securepayment=$_REQUEST['Ds_SecurePayment'];    	
			  $ds_merchantdata=$_REQUEST['Ds_MerchantData'];    	
			    	
			  $sha = new SHA1;
			  $message = $ds_amount.$ds_order.$ds_merchantcode.$ds_currency.$ds_response.$seed;
									
			  $digest1 = $sha->hash_string($message);
			  $signature = strtoupper ($sha->hash_to_string( $digest1 ));      
			      	
			  if ($signature!=$ds_signature)
			  {
			     //El proceso no puede ser completado, error de autenticacin
			    $error="Las firmas no coinciden: error de autenticacin";
			    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($error), 'SSL', true, false));   
			  }
			      	
			  $iresponse=(int)$ds_response;
			      	
			  if (($iresponse>=0) && ($iresponse<=99))
			  {
			  	 //Transaccin aprobada
			  }
			  else
			  {
			  	$errors=array();
			  	$errors[101]='Tarjeta caducada';
			  	$errors[102]='Tarjeta bloqueada por el banco emisor';  	
			  	$errors[107]='Orden de contactar con el banco emisor de la tarjeta';  	
			  	$errors[180]='Tarjeta no soportada por el sistema';  	
			  	$errors[184]='Autenticacin del titular de la tarjeta fallida';  	
			  	$errors[190]='Denegada por el banco emisor de la tarjeta por diversos motivos';  	
			  	$errors[201]='Tarjeta caducada. Orden de retirar la tarjeta';  	
			  	$errors[202]='Tarjeta bloqueada por el banco emisor. Orden de retirar la tarjeta';  	
					$errors[290]='Denegada por diversos motivos. Orden de retirar la tarjeta';
					$errors[909]='Error de sistema';
					$errors[912]='Centro resolutor no disponible';
					$errors[913]='Recibido mensaje duplicado';
					$errors[949]='Fecha de caducidad de la tarjeta errnea';
					$errors[9111]='Banco emisor de la tarjeta no responde';
					$errors[9093]='Nmero de tarjeta inexistente';
					$errors[9112]='Nmero de tarjeta inexistente';
					
			    //Transaccin denegada
			    $error=$errors[$iresponse];
			    if ($error=="") $error="Error desconocido ($iresponse)";
			    
			    	echo $error . ' <a href="' . tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($error), 'SSL', true, false) . '"> Volver a la tienda </a>';
			      die();  
			  }


    }
    
    
    function after_process()
    {
				return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SERVIRED_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Activar mdulo Servired', 'MODULE_PAYMENT_SERVIRED_STATUS', 'True', 'Quiere aceptar pagos usando Servired?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID Comercio', 'MODULE_PAYMENT_SERVIRED_ID_COM', '', 'Cdigo de comercio proporcionado por la entidad bancaria', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Clave de Encriptacin', 'MODULE_PAYMENT_SERVIRED_ID_SEED', 'qwertyasdf0123456789', 'Clave de encriptacin proporcionada por la entidad bancaria', '6', '4', now())");      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Terminal', 'MODULE_PAYMENT_SERVIRED_TERMINAL', '2', 'Numero de terminal: <br> XXXXXXXX-001 = terminal 1 <br>XXXXXXXX-002 = Terminal 2', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('URL de la pasarela de pago', 'MODULE_PAYMENT_SERVIRED_URL', 'https://sis-t.sermepa.es:25443/sis/realizarPago', 'Direccin en internet de la pasarela de pago', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('URL del Admin de la pasarela', 'MODULE_PAYMENT_SERVIRED_ADMIN', 'https://sis-t.sermepa.es:25443/canales', 'Direccin en internet del admin del TPV', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mail de pruebas', 'MODULE_PAYMENT_SERVIRED_MAIL', 'tuemail@dominio.com', 'Mail para fase de pruebas', '6', '4', now())");				                
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Orden de aparicion.', 'MODULE_PAYMENT_SERVIRED_SORT_ORDER', '0', 'Orden de aparicion. Nmero menor es mostrado antes que los mayores.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Zona de pago', 'MODULE_PAYMENT_SERVIRED_ZONE', '0', 'Si selecciona una zona, este mdulo slo estar disponible en esa zona.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Estado del pedido', 'MODULE_PAYMENT_SERVIRED_ORDER_STATUS_ID', '0', 'Seleccione el estado del pedido un vez procesado con este mdulo', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
		}

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array
      (
      'MODULE_PAYMENT_SERVIRED_STATUS',
      'MODULE_PAYMENT_SERVIRED_ID_COM',
      'MODULE_PAYMENT_SERVIRED_ID_SEED',
      'MODULE_PAYMENT_SERVIRED_TERMINAL',
      'MODULE_PAYMENT_SERVIRED_URL',
      'MODULE_PAYMENT_SERVIRED_ADMIN',
      'MODULE_PAYMENT_SERVIRED_MAIL',
      'MODULE_PAYMENT_SERVIRED_SORT_ORDER',
      'MODULE_PAYMENT_SERVIRED_ZONE',
      'MODULE_PAYMENT_SERVIRED_ORDER_STATUS_ID'
      );
    }
  }
  
// sha1 algorithm
class SHA1 {
        var $A, $B, $C, $D, $E;
        var $ta, $tb, $tc, $td, $te;
        var $K0_19, $K20_39, $K40_59, $K60_79;

        var $buffer;
        var $buffsize;
        var $totalsize;

        function SHA () {
                $this->init();
        }

        function init () {
                $this->A = 0x6745 << 16 | 0x2301;
                $this->B = 0xefcd << 16 | 0xab89;
                $this->C = 0x98ba << 16 | 0xdcfe;
                $this->D = 0x1032 << 16 | 0x5476;
                $this->E = 0xc3d2 << 16 | 0xe1f0;
                $this->ta = $this->A;
                $this->tb = $this->B;
                $this->tc = $this->C;
                $this->td = $this->D;
                $this->te = $this->E;
                $this->K0_19 = 0x5a82 << 16 | 0x7999;
                $this->K20_39 = 0x6ed9 << 16 | 0xeba1;
                $this->K40_59 = 0x8f1b << 16 | 0xbcdc;
                $this->K60_79 = 0xca62 << 16 | 0xc1d6;

                $this->buffer = array();
                $this->buffsize = 0;
                $this->totalsize = 0;
        }

        function bytes_to_words( $block ) {
                $nblk = array();
                for( $i=0; $i<16; ++$i) {
                        $index = $i * 4;
                        $nblk[$i] = 0;
                        $nblk[$i] |= ($block[$index] & 0xff) << 24;
                        $nblk[$i] |= ($block[$index+1] & 0xff) << 16;
                        $nblk[$i] |= ($block[$index+2] & 0xff) << 8;
                        $nblk[$i] |= ($block[$index+3] & 0xff);
                }
                return $nblk;
        }

        function pad_block( $block, $size ) {
                $blksize = sizeof( $block );
                $bits = $size * 8;

                $newblock = $block;
                $newblock[] = 0x80;
                while((sizeof($newblock) % 64) != 56) {
                        $newblock[] = 0;
                }
                for ($i=0; $i<8; ++$i) {
                        $newblock[] = ($i<4) ? 0 : ($bits >> ((7-$i)*8)) &0xff;
                }

                return $newblock;
        }

        function circ_shl( $num, $amt ) {
                $leftmask = 0xffff | (0xffff << 16);
                $leftmask <<= 32 - $amt;
                $rightmask = 0xffff | (0xffff << 16);
                $rightmask <<= $amt;
                $rightmask = ~$rightmask;

                $remains = $num & $leftmask;
                $remains >>= 32 - $amt;
                $remains &= $rightmask;

                $res = ($num << $amt) | $remains;

                return $res;
        }

        function f0_19( $x, $y, $z ) {
                return ($x & $y) | (~$x & $z);
        }

        function f20_39( $x, $y, $z ) {
                return ($x ^ $y ^ $z);
        }

        function f40_59( $x, $y, $z ) {
                return ($x & $y) | ($x & $z) | ($y & $z);
        }

        function f60_79( $x, $y, $z ) {
                return $this->f20_39( $x, $y, $z );
        }

        function expand_block( $block ) {
                $nblk = $block;
                for( $i=16; $i<80; ++$i ) {
                        $nblk[$i] = $this->circ_shl(
                                         $nblk[$i-3] ^ $nblk[$i-8] ^ $nblk[$i-14] ^ $nblk[$i-16], 1
                                );
                }

                return $nblk;
        }

        function print_bytes( $bytes ) {
                $len = sizeof( $bytes );
                for( $i=0; $i<$len; ++$i) {
                        $str[] = sprintf(  "%02x", $bytes[$i] );
                }

                print( join(  ", ", $str ) .  "\n" );
        }

        function wordstr( $word ) {
                return sprintf(
                         "%04x%04x", ($word >> 16) & 0xffff, $word & 0xffff
                        );
        }

        function print_words( $words ) {
                $len = sizeof( $words );
                for( $i=0; $i<$len; ++$i) {
                        $str[] = $this->wordstr( $words[$i] );
                }

                print( join(  ", ", $str ) .  "\n" );
        }

        function hash_to_string( $hash ) {
		$astr="";	// albert.martin(a)gmail.com -> si no se inicializa da un notice (tienes que tener el nivel de error reporting alto / E_ALL )
                $len = sizeof( $hash );
                for ($i=0; $i<$len; ++$i) {
                        $astr .= $this->wordstr( $hash[$i] );
                }
                return $astr;
        }

        function add( $a, $b ) {
                $ma = ($a >> 16) & 0xffff;
                $la = ($a) & 0xffff;
                $mb = ($b >> 16) & 0xffff;
                $lb = ($b) & 0xffff;

                $ls = $la + $lb;
                 // Carry
                if ($ls > 0xffff) {
                        $ma += 1;
                        $ls &= 0xffff;
                }

                $ms = $ma + $mb;
                $ms &= 0xffff;

                $result = ($ms << 16) | $ls;
                return $result;
        }

        function process_block( $blk ) {
                $blk = $this->expand_block( $blk );

                for( $i=0; $i<80; ++$i ) {
                        $temp = $this->circ_shl( $this->ta, 5 );
                        if ($i<20) {
                                $f = $this->f0_19( $this->tb, $this->tc,$this->td );
                                $k = $this->K0_19;
                        }
                        elseif ($i<40) {
                                $f = $this->f20_39( $this->tb, $this->tc,$this->td );
                                $k = $this->K20_39;
                        }
                        elseif ($i<60) {
                                $f = $this->f40_59( $this->tb, $this->tc,$this->td );
                                $k = $this->K40_59;
                        }
                        else {
                                $f = $this->f60_79( $this->tb, $this->tc,$this->td );
                                $k = $this->K60_79;
                        }

                        $temp = $this->add( $temp, $f );
                        $temp = $this->add( $temp, $this->te );
                        $temp = $this->add( $temp, $blk[$i] );
                        $temp = $this->add( $temp, $k );

                        $this->te = $this->td;
                        $this->td = $this->tc;
                        $this->tc = $this->circ_shl( $this->tb, 30 );
                        $this->tb = $this->ta;
                        $this->ta = $temp;
                }

                $this->A = $this->add( $this->A, $this->ta );
                $this->B = $this->add( $this->B, $this->tb );
                $this->C = $this->add( $this->C, $this->tc );
                $this->D = $this->add( $this->D, $this->td );
                $this->E = $this->add( $this->E, $this->te );
        }

        function update ( $bytes ) {
                $length = sizeof( $bytes );
                $index = 0;

                while (($length - $index) + $this->buffsize >= 64) {
                        for( $i=$this->buffsize; $i<64; ++$i) {
                                $this->buffer[$i] = $bytes[$index + $i -$this->buffsize];
                        }
                        $this->process_block( $this->bytes_to_words( $this->buffer ) );
                        $index += 64;
                        $this->buffsize = 0;
                }

                $remaining = $length - $index;
                for( $i=0; $i<$remaining; ++$i) {
                        $this->buffer[$this->buffsize + $i] = $bytes[$index+ $i];
                }
                $this->buffsize += $remaining;
                $this->totalsize += $length;
        }

        function finalizar () {
                for( $i=0; $i<$this->buffsize; ++$i) {
                        $last_block[$i] = $this->buffer[$i];
                }
                $this->buffsize = 0;
                $last_block = $this->pad_block( $last_block,$this->totalsize );
                $index = 0;
                $length = sizeof( $last_block );
                while( $index < $length )
                {
                        $block = array();
                        for( $i=0; $i<64; ++$i) {
                                $block[$i] = $last_block[$i + $index];
                        }
                        $this->process_block( $this->bytes_to_words( $block) );
                        $index += 64;
                }

                $result[0] = $this->A;
                $result[1] = $this->B;
                $result[2] = $this->C;
                $result[3] = $this->D;
                $result[4] = $this->E;

                return $result;
        }

        function hash_bytes( $bytes ) {
                $this->init();
                $this->update( $bytes );
                return $this->finalizar();
        }

        function hash_string( $str ) {
                $len = strlen( $str );
                for($i=0; $i<$len; ++$i) {
                        $bytes[] = ord( $str[$i] ) & 0xff;
                }
                return $this->hash_bytes( $bytes );
        }
}  
?>
